;   " " 
;  4 , RC 
; vladikas@mail.ru
; ICQ 321973179
;*********************************************************************************************** 

List              p=pic16f84a
__config          3FF3H

Status            equ      03h   ;  Status.
TrisB             equ      06h   ;       .
PortB             equ      06h   ;     .


;     

Timer_L_L         equ      0Ch   ;  L  . ___L- ____
Timer_H_L         equ      0Dh   ;  L  .

Timer_L_M         equ      0Eh   ;  M  . ___M-_____
Timer_H_M         equ      0Fh   ;  M  .

;  .      

Predel_L_L_0      equ      10h ;  L   0 ;    
Predel_H_L_0      equ      11h ;  L   0  

Predel_L_L_1      equ      12h ;  L   1 ;    
Predel_H_L_1      equ      13h ;  L   1

Predel_L_M_0      equ      14h ;  M   0 ;    
Predel_H_M_0      equ      15h ;  M   0

Predel_L_M_1      equ      16h ;  M   1 ;    
Predel_H_M_1      equ      17h ;  M   1

Priznak           equ      18h ;      

W           equ         0          ;    .
F           equ         1          ;    .


;   .

C           equ         0           ;   -.
Z           equ         2           ;    .


            org         0           ;    
            goto        START       ;   START.

START       
;   .
            movlw       .0            
            movwf       Timer_L_L   ;  L  
            movwf       Timer_H_L   ;  L  

            movwf       Timer_L_M   ;  M  
            movwf       Timer_H_M   ;  M  


;    "L"
;   0 (           "1")
;   1
            movlw       .200                  
            movwf       Predel_L_L_1 ;  __________  ___________
            movlw       .2
            movwf       Predel_H_L_1 ;  __________  ___________
;    0
            movlw       .13          
            movwf       Predel_L_L_0 
            movlw       .0
            movwf       Predel_H_L_0 ; 

;    "M"
;   0 (           "1")
;            ,    
;  1 
            movlw       .6           ;      
            movwf       Predel_L_M_1 
            movlw       .0
            movwf       Predel_H_M_1 ;            
;  0
            movlw       .5          ;
            movwf       Predel_L_M_0 ; __________  ___________
            movlw       .0
            movwf       Predel_H_M_0 ; __________  ___________


            bsf         Status,5    ;   1-  (  1 5-   Status).
            movlw       b'000111100';     (W).
            movwf       TrisB       ;  0  W   TrisB.
            bcf         Status,5    ;   0-  (  0 5-   Status).
            bcf         Status,2
            clrf        PortB       ;   

Goto        PLUS       ;  

PAUSE_1     nop        ;  -       ""      
            nop
goto        YES_1      ;    

PAUSE_2     nop         ;  ,      
            nop
goto        YES_2       ;    
                                    
YES         ;   "L"    1
            Movfw       Timer_H_L    ;       L 
            Xorwf       Predel_H_L_1,0  ;          0
            btfss       Status,Z        ;    2 ( Z)  Status.
            goto        PAUSE_1         ;    2 =0,     PAUSE_1,    YES_1

            movfw       Timer_L_L       ;       L
            xorwf       Predel_L_L_1,0  ;          0
            btfss       Status,Z        ;    2 ( Z)  Status.
goto        YES_1       ;    2 =0,     YES_1.

SET_L_1     bsf         PortB,0         ;   0  1    L
            clrf        Timer_H_L       ;    L
            clrf        Timer_L_L

goto        YES_1_1

YES_1      ;     ,  
            nop
            nop
            nop
            nop

YES_1_1     ;   "L"    0
            Movfw       Timer_H_L
            Xorwf       Predel_H_L_0,0  ;
            btfss       Status,Z        ;    2 ( Z)  Status.
            goto        PAUSE_2         ;    2 =0,     PAUSE_2,    YES_2.

            Movfw       Timer_L_L
            Xorwf       Predel_L_L_0,0  ;
            btfss       Status,Z        ;    2 ( Z)  Status.
goto        YES_2       ;    2 =0,     YES_2.


SET_L_0     bcf         PortB,0          ;   0  0    L
goto        YES_2_1

YES_2       nop         ;      
            nop

YES_2_1     ;   "M"    1
;  ,  ,   ,   ,    ,     
;           movfw       Timer_H_M       ;       M 
;           xorwf       Predel_H_M_1,0  ;          0
;           btfss       Status,Z        ;    2 ( Z)  Status.
;           goto        YES_3           ;    2 =0,     

            Movfw       Timer_L_M       ;       M
            Xorwf       Predel_L_M_1,0  ;          0
            btfss       Status,Z        ;    2 ( Z)  Status.
            goto        YES_3           ;    2 =0,     SET_M_1.

SET_M_1     bsf         PortB,1          ;   1  1    M
            clrf        Timer_H_M        ;    M
            clrf        Timer_L_M
goto        YES_3_1

YES_3       nop         ;     1,  
            nop
            nop
            nop

YES_3_1   ;   "M"    0

;           movfw       Timer_H_M
;           xorwf       Predel_H_M_0,0  ;
;           btfss       Status,Z        ;    2 ( Z)  Status.
;           goto        YES_3_2 ;PLUS   ;    2 =0,     PLUS.

            Movfw       Timer_L_M
            Xorwf        Predel_L_M_0,0 ;
            btfss       Status,Z        ;    2 ( Z)  Status.
Goto        YES_3_2     ;    2 =0,     SET_M_0.

SET_M_0     bcf          PortB,1         ;   1  0    M
Goto        PLUS

YES_3_2     nop         ;
            nop

PLUS        ; 
            movlw     .1              ; 
            addwf     Timer_L_L,F     ;    W  Timer_L_L      Timer_L_L.
            btfss     Status,C        ;    0 ( )  Status.
            goto      PLUS_M          ;    0 =0,     PLUS_M.
            incf      Timer_H_L,F     ;    0 =1,     Timer_H_L      .

PLUS_M      movlw     .1              ; 
            addwf     Timer_L_M,F     ;    W  Timer_L_M      Timer_L_M.
;            btfss    Status,C        ;    0 ( )  Status.
;            goto     YES             ;    0 =0,     .
;            incf     Timer_H_M,F     ;    0 =1,     Timer_H_M      .


;  
KNOPKI      btfsc     PortB,2         ; ,    L+
goto        PLUS_PRED_L               ;  ,    PLUS_L

            btfsc     PortB,3
goto        MINUS_PRED_L

            btfsc     PortB,4
goto        PLUS_PRED_M

            btfsc     PortB,5
goto        MINUS_PRED_M

goto        PRIZNAK_0  ;      

;========================================================================
;   
PLUS_PRED_L           ; " 1"      
            btfsc     Priznak,0       ;       ?
goto        PRIZNAK_1                 ;  ,    PRIZNAK_1
            movlw     .1              ;  ,   
            addwf     Predel_L_L_1,F
            btfss     Status,C        ;   ?
goto        PRIZNAK_1                 ;  ,   
            incf      Predel_H_L_1    ;  ,      
goto        PRIZNAK_1




MINUS_PRED_L          ; " 1"      
            btfsc     Priznak,0       ;       ?
goto        PRIZNAK_1                 ;  ,    PRIZNAK_1
            movlw     .1              ;  ,   
            subwf     Predel_L_L_1,F
            btfsc     Status,C        ;     ?
goto        PRIZNAK_1
            btfsc     Status,Z        ; 
goto        PRIZNAK_1
            movlw     .1              ; , .     
            subwf     Predel_H_L_1    ;  
            btfsc     Status,C        ; 
goto        PRIZNAK_1
            btfsc     Status,Z        ;    ?
goto        PRIZNAK_1                 ; 
            incf      Predel_H_L_1    ; , .    
goto        PRIZNAK_1





PLUS_PRED_M           ; " 1"      
            btfsc     Priznak,0       ;       ?
goto        PRIZNAK_1                 ; 
            movlw     .1              ;  ,   
            addwf     Predel_L_M_0,F
;            btfss     Status,C        ; 
;goto        PRIZNAK_1                 ; 
;            incf      Predel_H_M_0    ; 
goto        PRIZNAK_1




MINUS_PRED_M          ; " 1"      
            btfsc     Priznak,0       ;       ?
goto        PRIZNAK_1                 ; 
            movlw     .1              ;  ,   
            subwf     Predel_L_M_0,F
            btfsc     Status,C        ;     ?
goto        PRIZNAK_1
            btfsc     Status,Z        ; 
goto        PRIZNAK_1                 ; 
            incf      Predel_L_M_0    ; , .    
goto        PRIZNAK_1                 ; 







PRIZNAK_1   bsf       Priznak,0       ;   0   Priznak,      
goto        YES

PRIZNAK_0   bcf       Priznak,0       ;  ,    
goto        YES



            end                     ;  .
